package org.dvb.gem.companion;

/**
 * Manages states of {@link CompanionService}.
 */
public abstract class ServiceManager {

  /**
   * Registers a {@link CompanionService}.
   *
   * @param service
   *          {@link CompanionService} to register.
   */
  public void registerService(CompanionService service) {

  }

  /**
   * Unregisters a {@link CompanionService}.
   *
   * @param service
   *          {@link CompanionService} to unregister.
   */
  public void unregisterService(CompanionService service) {

  }

  /**
   * Returns the instance of {@link SecurityManager}.
   *
   * @return the instance.
   */
  public static ServiceManager getInstance() {
    return null;
  }

  /**
   * Starts a {@link CompanionService}. After start a UPnP Application
   * Management System sends a notification with an updated AppList.
   *
   * @param service
   *          {@link CompanionService} to start.
   */
  public void startService(CompanionService service) {

  }

  /**
   * Stops a {@link CompanionService}. After stop a UPnP Application Management
   * System sends a notification with an updated AppList.
   *
   * @param service
   *          {@link CompanionService} to stop.
   */
  public void stopService(CompanionService service) {

  }

  /**
   * Retrieves a list of started {@link CompanionService}.
   *
   * @return Array of started {@link CompanionService}.
   */
  public CompanionService[] getServices() {
    return null;
  }

  /**
   * Enters into the private mode by pausing all running
   * {@link CompanionService}.
   */
  public void enterPrivateMode() {

  }

  /**
   * Leaves from the Private Mode by resuming all paused
   * {@link CompanionService}.
   */
  public void leavePrivateMode() {

  }

  /**
   * Checks if the {@link ServiceManager} is currently in the Private Mode.
   *
   * @return true if the {@link ServiceManager} is in the Private Mode, false
   *         otherwise.
   */
  public boolean isInPrivateMode() {
    return false;
  }

}
