package org.dvb.gem.websocket;

/**
 * Represents end point of websocket connection.
 *
 */
public interface WebSocket {

  /**
   * Sends a text message to the other end of websocket connection.
   *
   * @param message
   *          A message to be sent
   */
  public void send(String message);

  /**
   * Returns true if the websocket is open.
   *
   * @return true if the websocket is open
   */
  public boolean isOpen();

  /**
   * Sends closings handshage and close the connection.
   */
  public void close();

}
