package org.dvb.gem.websocket;

import java.net.URI;

/**
 * Represents a client functionality of WebSocket.
 *
 */
public abstract class WebSocketClient implements WebSocket, WebSocketListener {

  /**
   * Creates WebSocketClient with the server endpoint.
   *
   * @param uri
   *          an URI where WebSocket server is available
   */
  public WebSocketClient(URI uri) {
  }

  /**
   * Connects to a WebSocket server available under URI passed in
   * {@link #WebSocketClient(URI)}
   */
  public abstract void connect();

  /**
   * Returns the client endpoint for the connection.
   *
   * @return endpoint represented by {@link WebSocket}
   */
  public abstract WebSocket getConnection();

}
