package org.dvb.gem.websocket;

/**
 * Methods called by {@link WebSocket}.
 */
public interface WebSocketListener {

  /**
   * Called after successful handshake.
   *
   * @param ws
   *          The {@link WebSocket} instance where this event happened
   */
  public void onWebsocketOpen(WebSocket ws);

  /**
   * Called after the call of WebSocket.close() or when the other endpoint of
   * the connection is closed.
   *
   * @param ws
   *          The {@link WebSocket} instance where this event happened
   */
  public void onWebsocketClose(WebSocket ws);

  /**
   * Called when a full message has been received.
   *
   * @param ws
   *          The {@link WebSocket} instance where this event happened
   * @param message
   *          received message
   */
  public void onWebsocketMessage(WebSocket ws, String message);

}
