package org.dvb.gem.websocket;

/**
 * Represent a server functionality of WebSocket.
 */
public abstract class WebSocketServer implements WebSocketListener {

  /**
   * Creates a {@link WebSocketServer} instance working on the specific TCP
   * port.
   *
   * @param port
   *          TCP port to be used.
   */
  public WebSocketServer(int port) {

  }

  /**
   * Returns an array of {@link WebSocket} currently connected clients.
   *
   * @return An arrays of connected {@link WebSocket}.
   */
  public abstract WebSocket[] getConnections();

  /**
   * Starts the server, binds to the chosen TCP port number and listens for
   * {@link WebSocket} connection requests.
   */
  public abstract void start();

  /**
   * Stops the servers, closes all connected clients, frees used TCP port.
   */
  public abstract void stop();

  /**
   * Sends a message to all connected clients.
   *
   * @param message
   *          A message to be sent.
   */
  public abstract void notifyAll(String message);

}
